﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectContainerShip.Entities
{
    internal class EntityContainerShip : EntityShip
    {
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; private set; }
        /// <summary>
        /// Признак (опция) наличия крана
        /// </summary>
        public bool Crane { get; private set; }
        /// <summary>
        /// Признак (опция) наличия дополнительных контейнеров
        /// </summary>
        public bool Container { get; private set; }
        /// <summary>
        /// Инициализация полей объекта-класса контейнеровоза
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес </param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="сrane">Признак наличия труб</param>
        /// <param name="сontainer">Признак наличия топлива</param>
        public EntityContainerShip(int speed, double weight, Color bodyColor, Color additionalColor, bool crane, bool container) : base(speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            Crane = crane;
            Container = container;
        }
    }
}
