using ProjectContainerShip.DrawningObjects;
using ProjectContainerShip.MovementStrategy;
using static ProjectContainerShip.Direction;

namespace ProjectContainerShip
{
    /// <summary>
    ///     ""
    /// </summary>
    public partial class FormContainerShip : Form
    {
        /// <summary>
        /// -   
        /// </summary>
        private DrawningShip? _drawingContainerShip;
        /// <summary>
        ///  
        /// </summary>
        private AbstractStrategy? _abstractStrategy;
        public DrawningShip? SelectedShip { get; private set; }
        /// <summary>
        ///  
        /// </summary>
        public FormContainerShip()
        {
            InitializeComponent();
            _abstractStrategy = null;
            _drawingContainerShip = null;
        }
        /// <summary>
        ///   
        /// </summary>
        private void Draw()
        {
            if (_drawingContainerShip == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxContainerShip.Width, pictureBoxContainerShip.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingContainerShip.DrawTransport(gr);
            pictureBoxContainerShip.Image = bmp;
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            Color color = Color.FromArgb(random.Next(0, 256),
            random.Next(0, 256), random.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _drawingContainerShip = new DrawningShip(random.Next(100, 300), random.Next(1000, 3000), color,
            pictureBoxContainerShip.Width, pictureBoxContainerShip.Height);
            _drawingContainerShip.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///    "   "
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreateDeckShip_Click(object sender, EventArgs e)
        {
            Random random = new();
            Color color = Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256));
            ColorDialog dialog2 = new();
            if (dialog2.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialog2.Color;
            }
            _drawingContainerShip = new DrawningContainerShip(random.Next(100, 300), random.Next(1000, 3000),
                color, dopColor, Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)),
            pictureBoxContainerShip.Width, pictureBoxContainerShip.Height);
            _drawingContainerShip.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawingContainerShip == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingContainerShip.MoveTransport(DirectionType.Up);
                break;
                case "buttonDown":
                    _drawingContainerShip.MoveTransport(DirectionType.Down);
                break;
                case "buttonLeft":
                    _drawingContainerShip.MoveTransport(DirectionType.Left);
                break;
                case "buttonRight":
                    _drawingContainerShip.MoveTransport(DirectionType.Right);
                break;
            }
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonStep_Click(object sender, EventArgs e)
        {
            if (_drawingContainerShip == null)
            {
                return;
            }
            if (comboBoxStrategy.Enabled)
            {
                _abstractStrategy = comboBoxStrategy.SelectedIndex
                switch
                {
                    0 => new MoveToCenter(),
                    1 => new MoveToBorder(),
                    _ => null,
                };
                if (_abstractStrategy == null)
                {
                    return;
                }
                _abstractStrategy.SetData(new DrawningObjectShip(_drawingContainerShip), pictureBoxContainerShip.Width, pictureBoxContainerShip.Height);
                comboBoxStrategy.Enabled = false;
            }
            if (_abstractStrategy == null)
            {
                return;
            }
            _abstractStrategy.MakeStep();
            Draw();
            if (_abstractStrategy.GetStatus() == Status.Finish)
            {
                comboBoxStrategy.Enabled = true;
                _abstractStrategy = null;
            }
        }
        private void buttonSelectShip_Click(object sender, EventArgs e)
        {
            SelectedShip = _drawingContainerShip;
            DialogResult = DialogResult.OK;
        }
        private void FormContainerShip_Load(object sender, EventArgs e)
        {
        }
    }
}
